/***********************************************************************/
/*                                                                     */
/*  FILE        :Main.c or Main.cpp                                    */
/*  DATE        :Tue, Oct 31, 2006                                     */
/*  DESCRIPTION :Main Program                                          */
/*  CPU TYPE    :                                                      */
/*                                                                     */
/*  NOTE:THIS IS A TYPICAL EXAMPLE.                                    */
/*                                                                     */
/***********************************************************************/
//#include "typedefine.h"
#ifdef __cplusplus
//#include <ios>                        // Remove the comment when you use ios
//_SINT ios_base::Init::init_cnt;       // Remove the comment when you use ios
#endif

void main(void);
#ifdef __cplusplus
extern "C" {
void abort(void);
}
#endif

#include "iodefine.h"

void main(void)
{
	int i;
	int HZ=0x5ca0;//1kHz
	int DUTY=20;//On

// clock setting
	SYSTEM.PRCR.WORD   = 0xa50b;	//NbN\[XI̕ی̉
	SYSTEM.PLLCR.WORD  = 0x0F00;	// PLL {~16 1 (12.000MHz * 16 = 192MHz)
	SYSTEM.PLLCR2.BYTE = 0x00;		// PLL ENABLE */
	SYSTEM.SCKCR.LONG  = 0x21C21211;//FCK1/4 ICK1/2 BCLK~ SDCLK~ BCK1/4 PCLKA1/2 PCLKB1/4
	SYSTEM.SCKCR2.WORD = 0x0032;	// UCLK1/4 IEBCK1/4
	SYSTEM.BCKCR.BYTE  = 0x01;		// BCLK = 1/2
	SYSTEM.SCKCR3.WORD = 0x0400;	//PLLHI
// IO setting
	PORTA.PDR.BIT.B6 = 1;//LED0
	PORTB.PDR.BIT.B0 = 1;//LED1
	PORTA.PDR.BIT.B4 = 1;//LED2
	PORTA.PDR.BIT.B0 = 1;//LED3
	PORT1.PDR.BIT.B5 = 1;//motor Enable
	PORTC.PDR.BIT.B5 = 1;//Rmotor CW/CCW
	PORTC.PDR.BIT.B6 = 1;//Lmotor CW/CCW
//port select
	MPC.PWPR.BIT.B0WI=0;
	MPC.PWPR.BIT.PFSWE=1;
	MPC.PB3PFS.BIT.PSEL=1;	//MTIOC0A buzzer
	MPC.P17PFS.BIT.PSEL=1;	//MTIOC3A Rmotor PWM for clock
	MPC.PE2PFS.BIT.PSEL=1;	//MTIOC4A Lmotor PWM for clock
	MPC.PWPR.BYTE=0x80;
	PORTB.PMR.BIT.B3=1;		//SP PWM
	PORT1.PMR.BIT.B7=1;		//EPWM
	PORTE.PMR.BIT.B2=1;		//PWM
//MTU setting
	SYSTEM.PRCR.WORD = 0xA502;
	MSTP(MTU) = 0;			//MTUW[ON
    SYSTEM.PRCR.WORD = 0xA500;	
	MTU.TSTR.BYTE=0;		//^C}Xgbv
	//Xs[J[pMTU
	MTU0.TCR.BIT.CCLR=2;	//PWM TGRB̃RyA}b`TCNTNA 
	MTU0.TCR.BIT.TPSC=1;	//PCLK/4 12MHz
	MTU0.TMDR.BIT.MD=2;		//PWM1
	MTU0.TIORH.BIT.IOA=5;	//RxA}b`lowhigh
	MTU0.TIORH.BIT.IOB=2;	//RxA}b`high
	MTU0.TGRA = 13636;		//440Hz
	MTU0.TGRB = (27272-1);
	//E[^pMTUݒ
	MTU3.TCR.BIT.TPSC=2;	//PCLK/16 3MHz
	MTU3.TCR.BIT.CCLR=1;	//PWM TGRÃRyA}b`TCNTNA
	MTU3.TIORH.BIT.IOA=2;	//o0yA}b`1o
	MTU3.TIORH.BIT.IOB=1;	//o0RyA}b`0o
	MTU3.TGRA = 3000;
	MTU3.TGRB = 50;
	MTU3.TGRC = 3000;
	MTU3.TMDR.BIT.MD=2;		//PWM1
	MTU3.TMDR.BIT.BFA = 1;	//obt@[[hɐݒ
	MTU3.TIER.BIT.TGIEB = 1;//GRARyA}b`ł̊荞݋
	IEN(MTU3,TGIB3) = 1;	//荞ݗv 
	IPR(MTU3,TGIB3) = 13;	//荞ݗDx_ɐݒ
	IR(MTU3,TGIB3)=0;		//荞݃Xe[^tONA
	//[^pMTUݒ
	MTU.TOER.BIT.OE4A=1;	//MTUo͒[qo͋
	MTU4.TCR.BIT.TPSC=2;	//PCLK/16 12MHz
	MTU4.TCR.BIT.CCLR=1;	//PWM TGRÃRyA}b`TCNTNA
	MTU4.TIORH.BIT.IOA=2;	//o0yA}b`1o
	MTU4.TIORH.BIT.IOB=1;	//o0RyA}b`0o
	MTU4.TGRA = 3000;
	MTU4.TGRB = 50;
	MTU4.TGRC = 3000;
	MTU4.TMDR.BIT.MD=2;		//PWM1
	MTU4.TMDR.BIT.BFA = 1;	//obt@[[hɐݒ
	MTU4.TIER.BIT.TGIEB = 1;//GRARyA}b`ł̊荞݋
	IEN(MTU4,TGIB4) = 1;	//荞ݗv 
	IPR(MTU4,TGIB4) = 12;	//荞ݗDx_ɐݒ
	IR(MTU4,TGIB4)=0;		//荞݃Xe[^tONA
	
	
	PORT1.PODR.BIT.B5=0;	//Motor Power Off
	PORTC.PODR.BIT.B5 = PORTC.PODR.BIT.B6 =0 ;//Forward

	MTU.TSTR.BIT.CST0 = 1;	//^C}X^[g
	MTU.TSTR.BIT.CST3 = 1;	//^C}X^[g
	MTU.TSTR.BIT.CST4 = 1;	//^C}X^[g


	while(1)
	{
		PORTB.PODR.BIT.B0 = 1;//_
		PORTA.PODR.BIT.B6 = 1;
		PORTA.PODR.BIT.B4 = 1;
		PORTA.PODR.BIT.B0 = 1;
		for(i = 0 ; i < (HZ*DUTY/100); i++);//ԑ҂
		PORTB.PODR.BIT.B0 = 0;//
		PORTA.PODR.BIT.B6 = 0;
		PORTA.PODR.BIT.B4 = 0;
		PORTA.PODR.BIT.B0 = 0;
		for(i = 0 ; i < (HZ*(100-DUTY)/100); i++);//ԑ҂
	}
}

#ifdef __cplusplus
void abort(void)
{

}
#endif
